<template>
    <p class="text-xl">Usuarios</p>
    <table class="table table-compact w-full">
        <tr>
            <th>Id</th>
            <th>Nombre</th>
            <th>Apellido</th>
            <th>Correo</th>
            <th>Rol</th>
            <th colspan="3">Opciones</th>
        </tr>
        <tr v-for="user in users" :key="user.usuId">
            <td>{{ user.usuId }}</td>
            <td>{{ user.nombre }}</td>
            <td>{{ user.apellidoPaterno }} {{ user.apellidoMaterno }}</td>
            <td>{{ user.correo }}</td>
            <td>{{ user.rol }}</td>
            <td class="w-24"><a class="btn btn-secondary text-white" href="#informacion" @click="selectUserInfo(user)">Detalles</a></td>
            <td class="w-24"><a class="btn btn-info text-white" @click="editUser(user)">Editar</a></td>
            <td class="w-24"><a class="btn btn-error text-white" href="#eliminar" v-if="user.usuId != adminId"
                    @click="selectUser(user.usuId)">Eliminar</a></td>
        </tr>
    </table>
    <a class="btn btn-primary" :href="'/admin/nuevo'">Crear Usuario</a>
    <div class="modal" id="informacion">
        <div class="p-5 bg-white rounded-3xl drop-shadow">
            <detallesUsuario :user="userSelectedInfo"></detallesUsuario>
            <div class="modal-action">
                <a href="#" class="btn btn-secondary text-white">Volver</a>
            </div>
        </div>
    </div>
    <div class="modal" id="eliminar">
        <div class="flex flex-col p-5 bg-white rounded-3xl gap-5 drop-shadow">
            <span>Desea eliminar el usuario ID={{ userSelected }}?</span>
            <div class="flex gap-5">
                <a class="btn btn-error text-white" @click="deleteSelectedUser()">Confirmar</a>
                <a href="#" class="btn btn-secondary text-white">Cancelar</a>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios'
import detallesUsuario from '../../components/CUENTAS/DetallesUsuario.vue'

export default {
    components: {
        detallesUsuario
    },
    data() {
        return {
            users: null,
            userSelected: 0,
            userSelectedInfo: {},
            adminId: localStorage.getItem('userId')
        }
    },
    mounted() {
        axios.get('cuentas/usuarios', {
            headers: {
                Authorization: localStorage.getItem('auth')
            }
        }).then( result => {
            this.users = result.data
        })
    },
    methods: {
        selectUser(id) {
            this.userSelected = id;
        },
        deleteSelectedUser() {
            axios.delete('cuentas/eliminar/' + this.userSelected, {
                headers: {
                    Authorization: localStorage.getItem('auth')
                }
            }).then(response => {
                alert("Usuario eliminado")
                console.log(response)
                window.location.href = "#"
                window.location.reload()
            })
        },
        selectUserInfo(SelectedUser){
            this.userSelectedInfo = SelectedUser
        },
        editUser(SelectedUser){
            this.userSelectedInfo = SelectedUser
            this.$router.push("/admin/editar/"+SelectedUser.usuId)
        }
    }
}
</script>

<style>

</style>